[![Pub Version](https://img.shields.io/pub/v/rive)](https://pub.dev/packages/rive)
![Build Status](https://github.com/rive-app/rive-flutter/actions/workflows/tests.yaml/badge.svg)
![Discord badge](https://img.shields.io/discord/532365473602600965)
![Twitter handle](https://img.shields.io/twitter/follow/rive_app.svg?style=social&label=Follow)

# Rive Flutter

![Rive hero image](https://cdn.rive.app/rive_logo_dark_bg.png)

Rive Flutter is a runtime library for [Rive](https://rive.app), a real-time interactive design and animation tool.

This library allows you to fully control Rive files with a high-level API for simple interactions and animations, as well as a low-level API for creating custom render loops for multiple artboards, animations, and state machines in a single canvas.

## Table of contents

- :star: [Rive Overview](#rive-overview)
- 🚀 [Getting Started & API docs](#getting-started)
- :mag: [Supported Platforms](#supported-platforms)
- :books: [Examples](#examples)
- 👨‍💻 [Contributing](#contributing)
- :question: [Issues](#issues)

## Overview of Rive

[Rive](https://rive.app) is a powerful tool that helps teams create and run interactive animations for apps, games, and websites. Designers and developers can use the collaborative editor to create motion graphics that respond to different states and user inputs, and then use the lightweight open-source runtime libraries, like Rive Flutter, to load their animations into their projects.

For more information, check out the following resources:

:house_with_garden: [Homepage](https://rive.app/)

:blue_book: [General help docs](https://help.rive.app/)

🛠 [Learning Rive](https://rive.app/learn-rive)

## Getting started

To get started with Rive Flutter, check out the following resources:
- [Getting Started with Rive in Flutter](https://help.rive.app/runtimes/overview/flutter)

- [Alternative Widget Setup](https://help.rive.app/runtimes/overview/flutter/alternative-widget-setup)

For additional help, see the Runtime sections of the Rive help documentation, such as:
- [Animation Playback](https://help.rive.app/runtimes/playback)
- [State Machines](https://help.rive.app/runtimes/state-machines)

## Supported platforms

Be sure to read the [platform specific considerations](platform_considerations.md) for the Rive Flutter package.

### Awesome Rive

For even more examples and resources on using Rive at runtime or in other tools, checkout the [awesome-rive](https://github.com/rive-app/awesome-rive) repo.

## Contributing

We love contributions and all are welcome! 💙

## Issues

Have an issue with using the runtime, or want to suggest a feature/API to help make your development life better? Log an issue in our [issues](https://github.com/rive-app/flutter/issues) tab! You can also browse older issues and discussion threads there to see solutions that may have worked for common problems.